EpiTicket/Controllers/PurchaseController.cs
using System;
using System.Linq;
using System.Threading.Tasks;
using EpiTicket.Models;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using Stripe;

namespace EpiTicket.Controllers
{
    public class PurchaseController : Controller
    {
        private readonly TicketContext _context;

        public PurchaseController(TicketContext context)
        {
            _context = context;
        }

        // GET: /<controller>/
        //[Authorize]
        public async Task<IActionResult> Index(string ID)
        {
            var info_event = await _context.Events
                .Include(e => e.Organizer)
                .FirstOrDefaultAsync(e => e.EventId == ID);
            if (info_event == null)
            {
                return Error();
            }
            var user = _context.Users.FirstOrDefault(u => u.Email == User.Identity.Name);
            ViewData["userName"] = user.FullName;
            ViewData["user"] = user;
            return View(info_event);
        }

        private IActionResult Error()
        {
            return View("Error");
        }

        public async Task<IActionResult> Charge(string stripeEmail, string stripeToken, string ID)
        {
            var info_event = _context.Events.FirstOrDefault(e => e.EventId == ID);
            if (info_event == null)
                return Error();
            var customers = new CustomerService();
            var charges = new ChargeService();

            var customer = customers.Create(new CustomerCreateOptions
            {
                Email = stripeEmail,
                SourceToken = stripeToken
            });

            var charge = charges.Create(new ChargeCreateOptions
            {
                Amount = Convert.ToInt32(info_event.Price) * 100,
                Description = "Event Purchase",
                Currency = "eur",
                CustomerId = customer.Id
            });

            if (ModelState.IsValid)
            {
                var user = _context.Users.FirstOrDefault(u => u.UserName == User.Identity.Name);
                var t = new Ticket { UserId = user.Id, EventId = ID };

                _context.Add(t);
                await _context.SaveChangesAsync();

                var ticket = _context.Tickets
                    .Include(tk => tk.User)
                    .Include(tk => tk.Event.Organizer)
                    .FirstOrDefault(tk => tk.TicketUUID == t.TicketUUID);

                return View(ticket);
            }

            return Error();
        }
    }

}

EpiTicket/Controllers/TicketController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using EpiTicket.Data;
using EpiTicket.Models;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using Microsoft.Extensions.Configuration;


namespace EpiTicket.Controllers
{
    public class TicketController : Controller
    {
        private readonly TicketContext _context;
        private readonly IConfiguration _configuration;

        public TicketController(TicketContext context,  IConfiguration configuration)
        {
            _context = context;
            _configuration = configuration;
        }

        // GET: /<controller>/
        public async Task<IActionResult> Detail(string id)
        {
            var ticket = await _context.Tickets
                .Include(t => t.Event.Organizer)
                .Include(t => t.User)
                .FirstOrDefaultAsync(t => t.TicketUUID == id);
            ViewData["QRCode"] = QRCodeManager.Base64FromURL(_configuration["BASE_URL"] + Request.Path.Value);
            return View(ticket);
        }
    }
}

EpiTicket/Views/Purchase/Charge.cshtml
@model EpiTicket.Models.Ticket

<h1>Récapitulatif d'achat</h1>
<hr />
<h3>You successfully paid <strong>@Model.Event.Price €</strong></h3>

@*qrcode*@
<div class="block">
    <dl class="row">
        <dt class="col-sm-2">
            Event
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Event.Name)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Event.Organizer)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(modelItem => Model.Event.Organizer.Name)

        </dd>
        <dt class="col-sm-2">
            Name
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => Model.User.FullName)
        </dd>
        <dt class="col-sm-2">
            Email
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => Model.User.Email)
        </dd>
    </dl>
</div>
<a asp-action="Detail" asp-controller="Ticket" asp-route-id="@Model.TicketUUID">Go to my ticket</a>

EpiTicket/Views/Purchase/Index.cshtml
@model EpiTicket.Models.Event
@using Microsoft.Extensions.Options
@using CloudinaryDotNet
@inject IOptions<EpiTicket.Stripe.StripeSettings> Stripe
@{
    ViewData["Title"] = "Purchase";
}

<h1>Panier</h1>

<div>
    <div class="event-container">
        <div class="left">
            <h3>
                Event
            </h3>
            <hr />
            <div class="block">
                @if (Model.Poster == null)
                {
                    @Html.Raw(EpiTicket.Data.Cloudinary.Instance.Api.UrlImgUp.Transform(
                                                                 new Transformation().Width(500).Height(300).Crop("fill").Radius("8")
                                                             ).BuildImageTag("EpiTicket/placeholder-event", new CloudinaryDotNet.StringDictionary("alt=" + Model.Name)))
                }
                else
                {
                    @Html.Raw(EpiTicket.Data.Cloudinary.Instance.Api.UrlImgUp.Transform(
                                                                         new Transformation().Width(500).Height(300).Crop("fill").Radius("8")
                                                                     ).BuildImageTag(Model.Poster, new CloudinaryDotNet.StringDictionary("alt=" + Model.Name)))
                }

                <dl class="row">
                    <dt class="col-sm-2">
                        @Html.DisplayNameFor(model => model.Name)
                    </dt>
                    <dd class="col-sm-10">
                        @Html.DisplayFor(model => model.Name)
                    </dd>
                    <dt class="col-sm-2">
                        @Html.DisplayNameFor(model => model.Organizer)
                    </dt>
                    <dd class="col-sm-10">
                        @Html.DisplayFor(modelItem => Model.Organizer.Name)
                    </dd>
                    <dt class="col-sm-2">
                        @Html.DisplayNameFor(model => model.Location)
                    </dt>
                    <dd class="col-sm-10">
                        @Html.DisplayFor(model => model.Location)
                    </dd>
                    <dt class="col-sm-2">
                        @Html.DisplayNameFor(model => model.StartDate)
                    </dt>
                    <dd class="col-sm-10">
                        @Convert.ToDateTime(Model.StartDate).ToString("dd/MM/yyyy")
                    </dd>
                    <dt class="col-sm-2">
                        Heure:
                    </dt>
                    <dd class="col-sm-10">
                        @Convert.ToDateTime(Model.StartDate).ToString("hh:mm")
                    </dd>
                </dl>
            </div>
        </div>
        <div class="right">
            <h3>
                Utilisateur
            </h3>
            <hr />
            <div class="block">
                <dl class="row">
                    <dt class="col-sm-2">
                        Name
                    </dt>
                    <dd class="col-sm-10">
                        @ViewData["userName"]
                    </dd>
                    <dt class="col-sm-2">
                        Email
                    </dt>
                    <dd class="col-sm-10">
                        @User.Identity.Name
                    </dd>
                </dl>
            </div>
        </div>
    </div>
    <div>
        <h3>
            Paiement
        </h3>
        <hr />
        <div>
            <dl class="row">
                <dt class="col-sm-2">
                    Achat:
                </dt>
                <dd class="col-sm-10">
                    1 ticket
                </dd>
                <dt class="col-sm-2">
                    Prix:
                </dt>
                <dd class="col-sm-10">
                    @Html.DisplayFor(model => model.Price) €
                </dd>
            </dl>
            <form action="/Purchase/Charge/@Model.EventId" method="POST">
                <script src="//checkout.stripe.com/v2/checkout.js"
                        class="stripe-button"
                        data-key="@Stripe.Value.PublishableKey"
                        data-locale="auto"
                        data-description="Event Purchase"></script>
            </form>
        </div>
    </div>
</div>